<?php
namespace EddCryptomus;

final class PaymentStatus
{
    const PAYMENT_STATUS_PROCESS = 'process';
    const PAYMENT_STATUS_CHECK = 'check';
    const PAYMENT_STATUS_PAID = 'paid';
    const PAYMENT_STATUS_FAIL = 'fail';
    const PAYMENT_STATUS_CANCEL = 'cancel';
    const PAYMENT_STATUS_WRONG_AMOUNT = 'wrong_amount';
    const PAYMENT_STATUS_PAID_OVER = 'paid_over';
    const PAYMENT_STATUS_SYSTEM_FAIL = 'system_fail';
    const PAYMENT_STATUS_REFUND_PROCESS = 'refund_process';
    const PAYMENT_STATUS_REFUND_FAIL = 'refund_fail';
    const PAYMENT_STATUS_REFUND_PAID = 'refund_paid';
    const PAYMENT_STATUS_WRONG_AMOUNT_WAITING = 'wrong_amount_waiting';
    const PAYMENT_STATUS_CONFIRM_CHECK = 'confirm_check';

    const WP_STATUS_PENDING = 'pending';
    const WP_STATUS_COMPLETED = 'complete';
    const WP_STATUS_REFUNDED = 'refunded';
    const WP_STATUS_FAIL = 'failed';
    const WP_STATUS_ABANDONED = 'abandoned';
    const WP_STATUS_REVOKED = 'revoked';
    const WP_STATUS_PREAPPROVED = 'preapproved';
    const WP_STATUS_CANCELED = 'cancelled';

    /**
     * @param $status
     * @return string
     */
    public static function convertToWPStatus($status)
    {
        switch ($status) {
            case self::PAYMENT_STATUS_PROCESS:
            case self::PAYMENT_STATUS_CHECK:
            case self::PAYMENT_STATUS_WRONG_AMOUNT_WAITING:
            case self::PAYMENT_STATUS_CONFIRM_CHECK:
            case self::PAYMENT_STATUS_REFUND_PROCESS:
            case self::PAYMENT_STATUS_WRONG_AMOUNT:
                $result = self::WP_STATUS_PENDING;
                break;

            case self::PAYMENT_STATUS_PAID:
            case self::PAYMENT_STATUS_PAID_OVER:
                $result = self::WP_STATUS_COMPLETED;
                break;

            case self::PAYMENT_STATUS_FAIL:
            case self::PAYMENT_STATUS_SYSTEM_FAIL:
            case self::PAYMENT_STATUS_REFUND_FAIL:
                $result = self::WP_STATUS_FAIL;
                break;

            case self::PAYMENT_STATUS_CANCEL:
                $result = self::WP_STATUS_CANCELED;
                break;

            case self::PAYMENT_STATUS_REFUND_PAID:
                $result = self::WP_STATUS_REFUNDED;
                break;

            default:
                $result = self::WP_STATUS_ABANDONED;
        }

        return $result;
    }
}